Package groovy.transform.stc

# Annotation Type ClosureParams

    @Target(PARAMETER)
    @Retention(RUNTIME)
    public @interface ClosureParams

Parameter annotation aimed at helping IDEs or the static type checker to infer the parameter types of a closure. Without this annotation, a method signature may look like this:

`public <T,R> List<R> doSomething(List<T> source, Closure<R> consumer)`

The problem this annotation tries to solve is to define the expected parameter types of the consumer closure. The generics type defined in `Closure<R>` correspond to the result type of the closure, but tell nothing about what the closure must accept as arguments.

There's no way in Java or Groovy to express the type signature of the expected closure call method from outside the closure itself, so we rely on an annotation here. Unfortunately, annotations also have limitations (like not being able to use generics placeholder as annotation values) that prevent us from expressing the type directly.

Additionally, closures are polymorphic. This means that a single closure can be used with different, valid, parameter signatures. A typical use case can be found when a closure accepts either a `Map.Entry` or a (key,value) pair, like the `DefaultGroovyMethods.each(java.util.Map, groovy.lang.Closure)` method.

For those reasons, the `ClosureParams` annotation takes these arguments:

- `value()` defines a `ClosureSignatureHint` hint class that the compiler will use to infer the parameter types
- `conflictResolutionStrategy()` defines a `ClosureSignatureConflictResolver` resolver class that the compiler will use to potentially reduce ambiguities remaining after initial inference calculations
- `options()`, a set of options that are passed to the hint when the type is inferred (and also available to the resolver)

As a result, the previous signature can be written like this:

`public <T,R> List<R> doSomething(List<T> source, @ClosureParams(FirstParam.FirstGenericType.class) Closure<R> consumer)`

Which uses the `FirstParam.FirstGenericType` first generic type of the first argument

hint to tell that the only expected argument type corresponds to the type of the first generic argument type of the first method parameter.

- ## Required Element Summary

  Required Elements
  Modifier and Type | Required Element | Description
  --- | --- | ---
  `java.lang.Class<? extends ClosureSignatureHint>` | `value` |

- ## Optional Element Summary

  Optional Elements
  Modifier and Type | Optional Element | Description
  --- | --- | ---
  `java.lang.Class<? extends ClosureSignatureConflictResolver>` | `conflictResolutionStrategy` |
  `java.lang.String[]` | `options` |

- ## Element Details

  - ### value

    java.lang.Class<? extends ClosureSignatureHint> value

- - ### conflictResolutionStrategy

    java.lang.Class<? extends ClosureSignatureConflictResolver> conflictResolutionStrategy
    Default:
      groovy.transform.stc.ClosureSignatureConflictResolver.class

  - ### options

    java.lang.String[] options
    Default:
      {}